"use strict";
{
	class skymen_FollowMouseManager {
		constructor() {
		}
		setMeEnabled(instance) {
			this.ignoreNextDisableMe = true;
			if (this.lastEnabled) this.lastEnabled.enabled = false;
			this.lastEnabled = instance;
			this.ignoreNextDisableMe = false;
		}
		setMeDisabled(instance) {
			if (this.ignoreNextDisableMe || instance !== this.lastEnabled) return;
			this.lastEnabled = null;
		}
	}

    const C3 = self.C3;
    C3.Behaviors.skymen_FollowMouse.Instance = class FollowMouseInstance extends C3.SDKBehaviorInstanceBase
    {
        constructor(behInst, properties)
        {
            super(behInst);

            //this._testProperty = 0;
            this.lastSetCursor = null;
            let mouseClass = this._runtime.GetSingleGlobalObjectClassByCtor(C3.Plugins.Mouse);
            this.mousePlugin = null;
            if (mouseClass) {
            	this.mousePlugin = mouseClass.GetSingleGlobalInstance()._sdkInst;
            } else {
            	console.error("You need the mouse plugin added in the project for this behavior to work properly.");
            }
            this.firstTick = true;
            this.isAlreadyChanging = false;
            this._enabled = false;
            
            if (!globalThis.skymen_FollowMouseManagerInstance)
           		globalThis.skymen_FollowMouseManagerInstance = new skymen_FollowMouseManager();
           	
            if (properties)
            {
                this.enabled = properties[0];
            }

            // Opt-in to getting calls to Tick()
        }
        
        get enabled() {
        	return this._enabled;
        }
        set enabled(val) {
        	if (this._enabled === !!val) return;
        	this._enabled = !!val;
        	if (this._enabled) {
        		globalThis.skymen_FollowMouseManagerInstance.setMeEnabled(this);
        		this._StartTicking();
        	}
        	else {
        		globalThis.skymen_FollowMouseManagerInstance.setMeDisabled(this);
        		this.lastSetCursor = null;
        	}
        }

        Release()
        {
            super.Release();
        }

        SaveToJson()
        {
            return {
                // data to be saved for savegames
            };
        }

        LoadFromJson(o)
        {
            // load state for savegames
        }

        SetCursorSprite(inst)
        {
            if (C3.Platform.IsMobile || !inst || !this.mousePlugin) return false;
            if (this.isAlreadyChanging) return true;
            const wi = inst.GetWorldInfo();
            const imageInfo = inst.GetCurrentImageInfo();
            if (!wi || !imageInfo) return false;
            if (this.lastSetCursor === imageInfo) return true;
            this.lastSetCursor = imageInfo;
            this.isAlreadyChanging = true;
            imageInfo
                .ExtractImageToCanvas()
                .then((canvas) => C3.CanvasToBlob(canvas))
                .then((blob) => {
	                const url = URL.createObjectURL(blob);
	                const cursorStyle = "url(" + url + ") " + Math.round(wi.GetOriginX() * imageInfo.GetWidth()) 
	                	+ " " + Math.round(wi.GetOriginY() * imageInfo.GetHeight()) + ", auto";
	                this.mousePlugin.PostToDOM("cursor", cursorStyle);
	            	this.isAlreadyChanging = false;
            	});
            return true;
        }
        
        RemoveCustomCursor() {
        	this.mousePlugin.PostToDOM("cursor", "");
        }


        Tick()
        {
        	if (!this.enabled) {
        		if (globalThis.skymen_FollowMouseManagerInstance.lastEnabled === null)
					this.RemoveCustomCursor();
        		this._StopTicking();
        		return;
        	}
        	if (!this.mousePlugin && this.firstTick) {
        		this.mousePlugin = this._runtime.GetSingleGlobalObjectClassByCtor(C3.Plugins.Mouse).GetSingleGlobalInstance()._sdkInst;
        		this.firstTick = false;
        	}
        	const wi = this._inst.GetWorldInfo();
        	let done = this.SetCursorSprite(this._inst);
        	wi.SetOpacity(done?0:1);
        	wi.SetCollisionEnabled(!done);

            // ... code to run every tick for this behavior ...
        }


        GetDebuggerProperties()
        {
            return [
            {
                title: "FollowMouse",
                properties: [
                    //{name: ".current-animation",	value: this._currentAnimation.GetName(),	onedit: v => this.CallAction(Acts.SetAnim, v, 0) },
                ]
            }];
        }
    };
}